package ru.landgrafhomyak.db.serdha0.api.table

import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

public interface CreateTableScope<tUE : Any> {
	public val types: DatabaseType.Provider

	public fun <RT, DT : DatabaseType<RT>> column(name: String, type: DT): Column<RT, DT, tUE>

	public fun index(name: String, vararg columns: Column<*, *, tUE>): Index<tUE>

	public fun uniqueIndex(name: String, distinctNulls: Boolean, vararg columns: Column<*, *, tUE>): UniqueIndex<tUE>
	public fun <cUE : Any> checkConstraint(name: String, creator: CheckConstraint.Creator<cUE, tUE>, recheckExistingRows: Boolean = false): CheckConstraint<tUE>
	public fun <cUE : Any, RT : Any, DT : DatabaseType<RT>> defaultValue(c: Column<RT, DT, tUE>, creator: DefaultConstraint.Creator<cUE, RT, DT, tUE>): DefaultConstraint<tUE>

	@Suppress("PropertyName")
	public val rowId_column: Column<RowId<tUE>, DatabaseType<RowId<tUE>>, tUE>

	@Suppress("PropertyName")
	public val rowId_uniqueConstraint: UniqueIndex<tUE>

	public fun <ttUE : Any> selfRowReference(
		onDelete: ForeignRowReference.OnDelete,
	): ForeignRowReference<tUE, tUE, RowId<tUE>, DatabaseType.ROW_ID<tUE>>

	public fun <ttUE : Any> nullableSelfRowReference(
		onDelete: ForeignRowReference.OnDelete,
	): ForeignRowReference<tUE, tUE, RowId<tUE>?, DatabaseType.Nullable<RowId<tUE>, DatabaseType.ROW_ID<tUE>>>

	public fun <ttUE : Any> foreignRowReference(
		columnName: String,
		toTable: Table<ttUE, *>,
		onDelete: ForeignRowReference.OnDelete,
	): ForeignRowReference<tUE, ttUE, RowId<ttUE>, DatabaseType.ROW_ID<ttUE>>

	public fun <ttUE : Any> nullableForeignRowReference(
		columnName: String,
		toTable: Table<ttUE, *>,
		onDelete: ForeignRowReference.OnDelete,
	): ForeignRowReference<tUE, ttUE, RowId<ttUE>?, DatabaseType.Nullable<RowId<ttUE>, DatabaseType.ROW_ID<ttUE>>>
}